searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `EthWallet`.\n\n  - 1. keys operations\n\n  - 2. generate signed tx\n\n    tx generated path:\n\n    build_tx -> hash_for_signing(serialize -> rlp encode -> kec) -> gen sig -> get signed tx\n\n    -> to raw tx-> send tx to node","ref":"EthWallet.html","title":"EthWallet","type":"module"},{"doc":"build transaction","ref":"EthWallet.html#build_tx/6","title":"EthWallet.build_tx/6","type":"function"},{"doc":"decrypt key with password.","ref":"EthWallet.html#decrypt_key/2","title":"EthWallet.decrypt_key/2","type":"function"},{"doc":"iex> EthWallet.decrypt_key(payload, \"bbc\")\n\n  \"ddd\"","ref":"EthWallet.html#decrypt_key/2-examples","title":"Examples - EthWallet.decrypt_key/2","type":"function"},{"doc":"encrypt key with password.","ref":"EthWallet.html#encrypt_key/2","title":"EthWallet.encrypt_key/2","type":"function"},{"doc":"iex> EthWallet.encrypt_key(\"ddd\", \"abc\")\n\n  <<40, 28, 220, 122, 235, 180, 216, 145, 142, 171, 53, 146, 25, 136, 47, 215>>","ref":"EthWallet.html#encrypt_key/2-examples","title":"Examples - EthWallet.encrypt_key/2","type":"function"},{"doc":"generate keys with/without privkey.","ref":"EthWallet.html#generate_keys/0","title":"EthWallet.generate_keys/0","type":"function"},{"doc":"iex> EthWallet.generate_keys()\n\n  %{\n    addr: \"0xd705f740d934acfb27df7bf71aadc00f20d03c7a\",\n    priv: <<21, ..., 166>>,\n    pub: <<4, ..., 165, ...>>\n  }","ref":"EthWallet.html#generate_keys/0-examples","title":"Examples - EthWallet.generate_keys/0","type":"function"},{"doc":"iex> EthWallet.generate_keys(<<21, ..., 166>>)\n\n  %{\n    addr: \"0xd705f740d934acfb27df7bf71aadc00f20d03c7a\",\n    priv: <<21, ..., 166, ...>>,\n    pub: <<4, ..., 165, ...>>\n  }","ref":"EthWallet.html#generate_keys/1","title":"EthWallet.generate_keys/1","type":"function"},{"doc":"recover pubkey by recovcery id, generated by sign compact","ref":"EthWallet.html#recover/4","title":"EthWallet.recover/4","type":"function"},{"doc":"sign uncompact, as sign in bitcoin.","ref":"EthWallet.html#sign/2","title":"EthWallet.sign/2","type":"function"},{"doc":"sign compact, as sign in ethereum.","ref":"EthWallet.html#sign_compact/3","title":"EthWallet.sign_compact/3","type":"function"},{"doc":"sign transaction","ref":"EthWallet.html#sign_tx/3","title":"EthWallet.sign_tx/3","type":"function"},{"doc":"signed transaction to raw transaction","ref":"EthWallet.html#signed_tx_to_raw_tx/1","title":"EthWallet.signed_tx_to_raw_tx/1","type":"function"},{"doc":"standard hash for msg signature.","ref":"EthWallet.html#standard_hash/1","title":"EthWallet.standard_hash/1","type":"function"},{"doc":"verify uncompact, fit to sign()","ref":"EthWallet.html#verify/3","title":"EthWallet.verify/3","type":"function"},{"doc":"verify by msg, sig and addr, fit to \"sign_compact()\"","ref":"EthWallet.html#verify_compact/3","title":"EthWallet.verify_compact/3","type":"function"},{"doc":"Tx about Ethereum.","ref":"EthWallet.Transaction.html","title":"EthWallet.Transaction","type":"module"},{"doc":"","ref":"EthWallet.Transaction.html#build_tx/6","title":"EthWallet.Transaction.build_tx/6","type":"function"},{"doc":"iex(80)> :binary.encode_unsigned(12345)\n\n  \"09\"\n\n  iex(81)> \"09\" <> <<0>>\n\n  <<48, 57, 0>>\n\n  iex(83)> 48 * 256 + 57\n\n  12345","ref":"EthWallet.Transaction.html#encode_unsigned/1","title":"EthWallet.Transaction.encode_unsigned/1","type":"function"},{"doc":"","ref":"EthWallet.Transaction.html#hash_for_signing/2","title":"EthWallet.Transaction.hash_for_signing/2","type":"function"},{"doc":"","ref":"EthWallet.Transaction.html#serialize/2","title":"EthWallet.Transaction.serialize/2","type":"function"},{"doc":"> https://b10c.me/blog/006-evolution-of-the-bitcoin-signature-length/\n\n  > https://bitcoin.stackexchange.com/questions/12554/why-the-signature-is-always-65-13232-bytes-long\n\n  Bitcoin:  0x30 [total-length] 0x02 [R-length] [R] 0x02 [S-length] [S]\n\n  Attetion: SigHash Flag should be append to the last in finally signature.\n\n  Ethereum: R <> S <> V (V = recid + chainID * 2 + 35)","ref":"EthWallet.Transaction.html#sign_tx/3","title":"EthWallet.Transaction.sign_tx/3","type":"function"},{"doc":"","ref":"EthWallet.Transaction.html#signed_tx_to_raw_tx/1","title":"EthWallet.Transaction.signed_tx_to_raw_tx/1","type":"function"},{"doc":"","ref":"EthWallet.Transaction.html#t:t/0","title":"EthWallet.Transaction.t/0","type":"type"},{"doc":"Crypto Lib","ref":"EthWallet.Utils.Crypto.html","title":"EthWallet.Utils.Crypto","type":"module"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#decrypt_key/2","title":"EthWallet.Utils.Crypto.decrypt_key/2","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#double_sha256/1","title":"EthWallet.Utils.Crypto.double_sha256/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#encrypt_key/2","title":"EthWallet.Utils.Crypto.encrypt_key/2","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#generate_key_secp256k1/0","title":"EthWallet.Utils.Crypto.generate_key_secp256k1/0","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#generate_key_secp256k1/1","title":"EthWallet.Utils.Crypto.generate_key_secp256k1/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#kec/1","title":"EthWallet.Utils.Crypto.kec/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#md5/1","title":"EthWallet.Utils.Crypto.md5/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#pad/2","title":"EthWallet.Utils.Crypto.pad/2","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#pubkey_to_address/1","title":"EthWallet.Utils.Crypto.pubkey_to_address/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#recover/4","title":"EthWallet.Utils.Crypto.recover/4","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#ripemd160/1","title":"EthWallet.Utils.Crypto.ripemd160/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#sha256/1","title":"EthWallet.Utils.Crypto.sha256/1","type":"function"},{"doc":":crypto.sign(:ecdsa, :sha256, msg, [privkey, :secp256k1])\n\n  equal to\n\n  msg |> sha256() |> :libsecp256k1.ecdsa_sign\n\n  > sig format: 0x30 [total-length] 0x02 [R-length] [R] 0x02 [S-length] [S]\n\n  - sha256 digest using for bitcoin","ref":"EthWallet.Utils.Crypto.html#sign/2","title":"EthWallet.Utils.Crypto.sign/2","type":"function"},{"doc":"The test is here:\n\n  https://github.com/exthereum/exth_crypto/blob/master/lib/signature/signature.ex\n\n  Attention: hash should be 32 bytes.","ref":"EthWallet.Utils.Crypto.html#sign_compact/3","title":"EthWallet.Utils.Crypto.sign_compact/3","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#unpad/1","title":"EthWallet.Utils.Crypto.unpad/1","type":"function"},{"doc":"The test is here:\n\n  https://github.com/exthereum/exth_crypto/blob/master/lib/signature/signature.ex\n\n  Attention: hash should be 32 bytes.","ref":"EthWallet.Utils.Crypto.html#verify/3","title":"EthWallet.Utils.Crypto.verify/3","type":"function"},{"doc":"","ref":"EthWallet.Utils.Crypto.html#verify_compact/3","title":"EthWallet.Utils.Crypto.verify_compact/3","type":"function"},{"doc":"ExSha3 supports the three hash algorithms:\n    * KECCAK1600-f the original pre-fips version as used in Ethereum\n    * SHA3 the fips-202 approved final hash\n    * SHAKE\n  Keccak and SHA3 produce fixed length strings corresponding to their\n  bit length, while shake produces an arbitary length output according\n  to the provided outlen parameter.","ref":"EthWallet.Utils.ExSha3.html","title":"EthWallet.Utils.ExSha3","type":"module"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#keccak_224/1","title":"EthWallet.Utils.ExSha3.keccak_224/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#keccak_256/1","title":"EthWallet.Utils.ExSha3.keccak_256/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#keccak_384/1","title":"EthWallet.Utils.ExSha3.keccak_384/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#keccak_512/1","title":"EthWallet.Utils.ExSha3.keccak_512/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#sha3_224/1","title":"EthWallet.Utils.ExSha3.sha3_224/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#sha3_256/1","title":"EthWallet.Utils.ExSha3.sha3_256/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#sha3_384/1","title":"EthWallet.Utils.ExSha3.sha3_384/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#sha3_512/1","title":"EthWallet.Utils.ExSha3.sha3_512/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#shake_128/2","title":"EthWallet.Utils.ExSha3.shake_128/2","type":"function"},{"doc":"","ref":"EthWallet.Utils.ExSha3.html#shake_256/2","title":"EthWallet.Utils.ExSha3.shake_256/2","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html","title":"EthWallet.Utils.TypeTranslator","type":"module"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#addr_to_bin/1","title":"EthWallet.Utils.TypeTranslator.addr_to_bin/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#data_to_addr/1","title":"EthWallet.Utils.TypeTranslator.data_to_addr/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#data_to_int/1","title":"EthWallet.Utils.TypeTranslator.data_to_int/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#data_to_str/1","title":"EthWallet.Utils.TypeTranslator.data_to_str/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#hex_to_bin/1","title":"EthWallet.Utils.TypeTranslator.hex_to_bin/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#hex_to_bytes/1","title":"EthWallet.Utils.TypeTranslator.hex_to_bytes/1","type":"function"},{"doc":"","ref":"EthWallet.Utils.TypeTranslator.html#hex_to_int/1","title":"EthWallet.Utils.TypeTranslator.hex_to_int/1","type":"function"},{"doc":"Fetch from:\n  > https://github.com/Metalink-App/web3x/blob/master/lib/web3x/wallet.ex","ref":"EthWallet.Web3x.Wallet.html","title":"EthWallet.Web3x.Wallet","type":"module"},{"doc":"Destructure a signature to r, s, v to be used by Secp256k1 recover","ref":"EthWallet.Web3x.Wallet.html#destructure_sig/1","title":"EthWallet.Web3x.Wallet.destructure_sig/1","type":"function"},{"doc":"Get Public Ethereum Address from Public Key","ref":"EthWallet.Web3x.Wallet.html#get_address/1","title":"EthWallet.Web3x.Wallet.get_address/1","type":"function"},{"doc":"","ref":"EthWallet.Web3x.Wallet.html#get_nonce/1","title":"EthWallet.Web3x.Wallet.get_nonce/1","type":"function"},{"doc":"","ref":"EthWallet.Web3x.Wallet.html#hash_message/1","title":"EthWallet.Web3x.Wallet.hash_message/1","type":"function"},{"doc":"Strip 0x prefix from a binary","ref":"EthWallet.Web3x.Wallet.html#strip_hex_prefix/1","title":"EthWallet.Web3x.Wallet.strip_hex_prefix/1","type":"function"},{"doc":"Verifies if a message was signed by a wallet keypair given a the public address, message, signature","ref":"EthWallet.Web3x.Wallet.html#verify_message?/3","title":"EthWallet.Web3x.Wallet.verify_message?/3","type":"function"},{"doc":"Verifies if a message was signed by a wallet keypair given a the public address, message, signature, and nonce in the message","ref":"EthWallet.Web3x.Wallet.html#verify_message?/4","title":"EthWallet.Web3x.Wallet.verify_message?/4","type":"function"},{"doc":"","ref":"EthWallet.Web3x.Wallet.html#verify_signature/2","title":"EthWallet.Web3x.Wallet.verify_signature/2","type":"function"}]}